	subroutine auto_help_init(ptr_terminal_info)
	implicit none
c
	include 'terminal.inc'
	integer*4 ptr_terminal_info
c
	record /terminal_info/ terminal_info
	pointer (p_terminal_info,terminal_info)
c
	p_terminal_info = ptr_terminal_info
	terminal_info.nk_help = 0
c
	return
	end
	function auto_help_add(ptr_terminal_info,topic)
	implicit none
c
c Add the topic to the help line
c  if the length of help_line wold be exceeded, return false
c  else append topic to help line and return true
c
	include 'terminal.inc'
	integer*4 ptr_terminal_info
	character*(*) topic		!;i: topic to add
	logical auto_help_add		!:f: false if string full
c
	integer*4 nk_help
c
	character*(*) help_terminator
	parameter (help_terminator = '..<more>..')
c
	record /terminal_info/ terminal_info
	pointer (p_terminal_info,terminal_info)
c
c See if room
c
	p_terminal_info = ptr_terminal_info
c
	if(terminal_info.nk_help+len(topic) + len(help_terminator) .ge. 
     1     terminal_info.max_help_size) then
c
c No, fill with ..<more>..
c Insert a >
c
	  terminal_info.help_line(terminal_info.nk_help+1:) = help_terminator
	  terminal_info.nk_help = terminal_info.nk_help +len(help_terminator)
c
c And return false
c
	  auto_help_add = .false.
	else
c
c Yes, insert , and topic
c
	  nk_help = terminal_info.nk_help
	  if(nk_help .gt. 0) then
	    nk_help = nk_help + 1
	    terminal_info.help_line(nk_help:nk_help) = ','
	  endif
	  terminal_info.help_line(nk_help+1:nk_help+len(topic)) = topic
	  terminal_info.nk_help = nk_help + len(topic)
	  auto_help_add = .true.
	endif
c
	return
	end
	function auto_help_display(ptr_terminal_info,token)
	implicit none
c
	include 'terminal.inc'
	integer*4 ptr_terminal_info
	integer*4 auto_help_display
	character*(*) token
c
	integer*4 istat
c
	external auto_msg_help
	integer*4 auto_msg
c
	record /terminal_info/ terminal_info
	pointer (p_terminal_info,terminal_info)
c
	p_terminal_info = ptr_terminal_info
c
	istat = auto_msg(ptr_terminal_info,auto_msg_help,token,
     1           terminal_info.help_line(1:terminal_info.nk_help))
	auto_help_display = istat
	return
	end
	function auto_help_help(verb,token,image,par_nr,ptr_terminal_info)
	implicit none
c
	include 'auto.inc'
c
	character*(*) verb		!:i: the verb to display help about
	character*(*) token		!:i: the qualifier/parameter
	character*(*) image		!:i: the image name ' ' for normal verbs
c                                                           '@' for dcl-procs
c                                                           '#' for auto help 
	integer*4 par_nr                !:i: parameter number (or 0)
	integer*4 ptr_terminal_info	!:i: terminal info
	integer*4 auto_help_help	!:f: function result
c
	integer*4 istat,nk,nk_help,flag,context,nk1
	integer*4 bpos,epos,nk_vs
	logical*4 display_message
	character*255 helplib,line,verb_searched
c
	integer*4 help_routine_addr
	save help_routine_addr
	data help_routine_addr/0/
c
	integer*4 auto_msg
	integer*4 get_len
	integer*4 lib$find_image_symbol
	integer*4 lib$find_file
	integer*4 str$case_blind_compare
c
	integer*4 terminal_redraw
	integer*4 lbr$output_help
c
	external auto_msg_helpinfo
	external auto_msg_helpinfol
c
	integer*4 lib$get_input
	integer*4 lib$put_output
	external lib$get_input
	external  lib$put_output
c
	integer*4 auto_ignore_message
	external auto_ignore_message
	integer*4 auto_help_find_verb
c
	integer*4 help_routine
	external help_routine
	pointer (p_help_routine,help_routine)
c
c
	display_message = .false.
	nk = get_len(image)
c
c See if we can find the fshelp help shareable image
c
	if(help_routine_addr .eq. 0) then
c
c The first time, try to locate the FSHELP help library
c
	  call lib$establish(auto_ignore_message)
	  istat = lib$find_image_symbol('fshelp_shr','fshelp_display_help',
     1                                 help_routine_addr)
	  call lib$revert
	  if(.not.istat) help_routine_addr = -1
	endif
c
c If the verb is empty, display help about auto
c
	if(verb .eq. ' ') then
	  call sys$fao('AUTO',nk,line)
	  goto 35
	endif
c
c
c  If image = '' ,help must be in helplib
c
	if(image .eq. ' ') then
c
c No image, help must be in SYS$HELP:HELPLIB.HLB
c
	  call sys$fao('sys$help:helplib.hlb',nk_help,helplib)
	  call sys$fao('!AS !AS',nk,line,verb,token)
c
	elseif(image .eq. '@') then
c
c We had a symbol, look for help about @VERB parameter n
c
	  call auto_help_get_helplib(helplib,nk_help)
	  call sys$fao('@!AS !AS',nk,line,verb,token) 
	elseif(image .eq. '#') then
c
c Help about auto itself
c
	  call sys$fao('!AS',nk,line,verb)
	  goto 35
	else
c
c Separate image, look for its help database??
c  look for an image sys$help:imagname.hlb
c
c If the image ends on a _ALPHA, _VAX or _IA64 skip that part
c
	  call auto_file_parse(image,'N',bpos,epos)
	  if(    str$case_blind_compare(image(epos-5:epos),'_ALPHA')) then
	    epos = epos - 6
	  elseif(str$case_blind_compare(image(epos-3:epos),'_VAX'  )) then
	    epos = epos - 4
	  elseif(str$case_blind_compare(image(epos-4:epos),'_IA64' )) then
	    epos = epos - 5
	  endif	
c
	  nk_help = 0
c
10	  context = 0
	  istat = lib$find_file(image(bpos:epos),
     1                          helplib,context,'SYS$HELP:.HLB')
	  call lib$find_file_end(context)
	  if(istat) goto 20
c
c Look for the imagnameHLP.HLB
c
	  context = 0
	  istat = lib$find_file(image(bpos:epos)//'HLP',
     1                          helplib,context,'SYS$HELP:.HLB')
	  call lib$find_file_end(context)
	  if(istat) goto 20
c
c Look for the imagname_HLP.HLB
c
	  context = 0
	  istat = lib$find_file(image(bpos:epos)//'_HLP',
     1                          helplib,context,'SYS$HELP:.HLB')
	  call lib$find_file_end(context)
	  if(istat) goto 20
c
c Look for the imagname$HELP.HLB
c
	  context = 0
	  istat = lib$find_file(image(bpos:epos)//'$HELP',
     1                          helplib,context,'SYS$HELP:.HLB')
	  call lib$find_file_end(context)
	  if(istat) goto 20
c
c Not found, we can retry for the same directory as the image
c  if bpos>1, set it to 1 and retry
c
	  if(bpos .gt. 1) then
	    bpos = 1
	    goto 10
	  endif
c
c We found a helplibrary, or not found after all options
c  If (istat) we have one
c
20	  if(istat) then
	    nk_help = get_len(helplib)
	    call sys$fao('!AS !AS',nk,line,verb,token) 
c
c Do not check if the entry is there
c
	    goto 40
	  else
c
c Not found, try the auto_help.hlb, with the $ in front
c
	    call auto_help_get_helplib(helplib,nk_help)
	    call sys$fao('$!AS !AS',nk,line,verb,token) 
	  endif
c
c THis library must be the correct one
c
	endif
c
c If helplib not found, we must try in AUTO_HELP.HLB
c
	if(nk_help .eq. 0) goto 30
c
c We have ahelp library, try to locate the verb
c  if it cannot be found, we must use AUTO_HELP.HLB
c
	nk_vs = index(line,' ')-1
	verb_searched = line(1:nk_vs)
	if(auto_help_find_verb(verb_searched(1:nk_vs),
     1                         helplib(1:nk_help))) goto 40
c
c Either no help library found, or the verb is not found
c Now use the help page of auto with verb info
c
30	call sys$fao('auto info',nk,line)
	display_message = .true.
c
35	call auto_help_get_helplib(helplib,nk_help)
c
c If par_nr <>0, add the parameter number as Pn
c 
40	if(par_nr .ne. 0) then
	  call sys$fao(' P!UL',nk1,line(nk+1:),%val(par_nr))
	  nk = nk + nk1
	endif
c
c We have a help lib and a help line, see if we can use fhselp_shr
c
	if(help_routine_addr .ne. -1) then
c
c Yes , lets do it
c
	  p_help_routine = help_routine_addr
	  flag = 16		!nodown option
	  istat = help_routine(helplib(1:nk_help),line(1:nk),flag)
	else
c
c Nu fshelp_shr, use lbr$output_help
c
          istat = lbr$output_help(lib$put_output,80,line(1:nk),
     1               helplib(1:nk_help),,lib$get_input)
c
        endif
	if(.not. istat) goto 90
c
c If the help was about auto itself, skip
c
	if(ptr_terminal_info .eq. 0) goto 90
c
c Redraw the current line
c
	
	istat = terminal_redraw(ptr_terminal_info)
	if(.not. istat) goto 90
c
	if(display_message) then
	  nk1 = index(line,' ')-1
	  istat=auto_msg(ptr_terminal_info,auto_msg_helpinfol,
     1                     verb_searched(1:nk_vs),
     1                     helplib(1:nk_help))
	endif
c
90	auto_help_help = istat
	return
	end		
	function auto_help_find_verb(verb,helplib)
	implicit none
c
c Return true if verb can be found in helplib
c
	include '($lbrdef)'
	character*(*) verb
	character*(*) helplib
	integer*4 auto_help_find_verb
c
	integer*4 istat,lbr_index
c
	integer*4 lbr$ini_control
	integer*4 lbr$open
	integer*4 lbr$get_index
	integer*4 auto_help_match
	external auto_help_match
c
	character*80 line
	integer*4 nk
c
	call str$upcase(line,verb//'*')
	nk = len(verb)+1
c
	istat = lbr$ini_control(lbr_index,lbr$c_read,lbr$c_typ_hlp)
	if(istat) then
	  istat = lbr$open(lbr_index,helplib)
	  if(istat) then
	    istat = lbr$get_index(lbr_index,1,auto_help_match,line(1:nk))
	  else
	  endif
	  call lbr$close(lbr_index)
	endif
	auto_help_find_verb = istat
	return
	end
c
	function auto_help_match(key,rfa)
	implicit none
c
	character*(*) key
	integer*4 rfa
	integer*4 auto_help_match
c
	integer*4 x
c
	if(len(key) .gt. 0) x=rfa	!to prevent compiler warnings
	auto_help_match = 1
	return
	end
	subroutine auto_help_get_helplib(helplib,nk_help)
	implicit none
c
	character*(*) helplib
	integer*4 nk_help
c
	character*255 line
	include '($jpidef)'
c
	integer*4 context,nk,istat
	integer*4 lib$find_file
	integer*4 get_len
c
c Try to locate a help library
c  Name  auto_help , default sys$help:
c  can be overriden with a logical 
c 
	context = 0
	istat = lib$find_file('auto_help',helplib,
     1                           context,'sys$help:.hlb')
	call lib$find_file_end(context)
c
c If not found there, try the directory of auto image
c
	if(.not. istat) then
	  call lib$getjpi(jpi$_imagname,,,,line,nk)
	  context = 0
	  istat = lib$find_file('auto_help.hlb;0',helplib,
     1                           context,line(1:nk))
	  call lib$find_file_end(context)
	endif
	if(istat) then
	  nk_help = get_len(helplib)
	else
	  nk_help = 0
	endif
	return
	end
